import { Module, Type } from '@nestjs/common';
import { ServerController } from 'src/modules/server/server.controller';
import { ServerService } from 'src/modules/server/server.service';
import { ServerRepository } from 'src/modules/server/repositories/server.repository';
import { LocalServerRepository } from 'src/modules/server/repositories/local.server.repository';

@Module({})
export class ServerModule {
  static register(
    serverRepository: Type<ServerRepository> = LocalServerRepository,
  ) {
    return {
      module: ServerModule,
      controllers: [ServerController],
      providers: [
        ServerService,
        {
          provide: ServerRepository,
          useClass: serverRepository,
        },
      ],
    };
  }
}
